<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="规格名称" prop="name">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入规格名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['product:rule:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['product:rule:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['product:rule:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['product:rule:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="ruleList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="主键" align="center" prop="id" />
      <el-table-column label="规格名称" align="center" prop="name" />
      <el-table-column label="规格属性名" align="center" prop="name" >
        <template slot-scope="scope">
          <el-row v-for="ruleAttr in scope.row.ruleAttrList"><span>{{ruleAttr.name}}</span></el-row>
        </template>
      </el-table-column>
      <el-table-column label="规格属性值" align="center" prop="name" >

        <template slot-scope="scope">
          <el-row v-for="ruleAttr in scope.row.ruleAttrList"><span>{{ruleAttr.valueList.toString()}}</span></el-row>

        </template>
      </el-table-column>
      <el-table-column label="规格状态" align="center" prop="status">
        <template slot-scope="scope">
          <el-switch
            style="display: block"
            v-model="scope.row.status"
            active-color="#13ce66"
            inactive-color="#ff4949"
            active-value="Y"
            inactive-value="N"
            active-text="开启"
            inactive-text="关闭"
          @change="updRuleUpdStatus(scope.row)">
          </el-switch>
        </template>
      </el-table-column>

      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['product:rule:edit']"
            :disabled="scope.row.flan===true"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['product:rule:remove']"
            :disabled="scope.row.flan===true"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改商品规格对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="80%" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="规格名称" prop="name">
          <el-input v-model="form.name" placeholder="请输入规格名称" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入内容" />
        </el-form-item>
        <el-row v-for="(ruleAttr, index) in form.ruleAttrList">
          <el-row style="margin: 20px 0">
            <el-tag
              :key="ruleAttr.name"
              @close="removeRule(index)"
              closable>
              {{ruleAttr.name}}
            </el-tag>
          </el-row>
          <el-row style="margin: 10px 0">
            <el-tag
              style="float: left; margin-right: 20px"
              v-for="(ruleProperty, index) in ruleAttr.valueList"
              :key="ruleProperty"
              @close="removeRuleProperty(ruleAttr.valueList, index)"
              closable>
              {{ruleProperty}}
            </el-tag>
            <el-button v-if="!ruleAttr.ruleAttrAddStatus" @click="ruleAttr.ruleAttrAddStatus = !ruleAttr.ruleAttrAddStatus" size="mini">添加</el-button>
            <el-input v-if="ruleAttr.ruleAttrAddStatus"
                      v-model="addRulePropertyValue"
                      @blur="addRuleProperty(ruleAttr, false)"
                      @keyup.enter.native="addRuleProperty(ruleAttr, true)"
                      size="mini" placeholder="请输入规格属性值" style="float: left; width: 150px"/>
          </el-row>
          <el-divider></el-divider>
        </el-row>
        <el-button v-if="!ruleAddFormStatus" @click="ruleAddFormStatus = !ruleAddFormStatus">添加规格</el-button>
        <el-form v-if="ruleAddFormStatus" :inline="true" :model="ruleAddForm" class="demo-form-inline">
          <el-form-item label="规格名称">
            <el-input v-model="ruleAddForm.name" placeholder="请输入规格名称"></el-input>
          </el-form-item>
          <el-form-item label="规格属性">
            <el-input v-model="ruleAddForm.valueList" placeholder="请输入规格属性"></el-input>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" @click="ruleAddFormFun">添加</el-button>
          </el-form-item>
        </el-form>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listRule, getRule, delRule, addRule, updateRule, updateStatusRule } from '@/api/product/rule'

export default {
  name: "Rule",
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 商品规格表格数据
      ruleList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        name: null,
        status: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        createBy: [
          { required: true, message: "创建人不能为空", trigger: "blur" }
        ],
        createTime: [
          { required: true, message: "创建时间不能为空", trigger: "blur" }
        ],
      },
      ruleAddForm: {
        name: null,
        valueList: null,
      },
      ruleAddFormStatus: false,
      addRulePropertyValue: null
    };
  },
  created() {
    this.getList();
  },
  methods: {
    removeRule(index){
      this.form.ruleAttrList.splice(index, 1);
    },
    removeRuleProperty(valueList,index){
      valueList.splice(index, 1);
    },
    addRuleProperty(ruleAttr, continuousInput){
      if (this.addRulePropertyValue === null || this.addRulePropertyValue === 0){
        if (!continuousInput){
          ruleAttr.ruleAttrAddStatus = !ruleAttr.ruleAttrAddStatus
        }
        return;
      }
      if (ruleAttr.valueList.indexOf(this.addRulePropertyValue) > -1){
        this.$message({
          message: `规格[${ruleAttr.name}]属性值[${this.addRulePropertyValue}]已经存在`,
          type: 'warning'
        });
        return;
      }
      ruleAttr.valueList.push(this.addRulePropertyValue)
      this.addRulePropertyValue = null;
      if (!continuousInput){
        ruleAttr.ruleAttrAddStatus = !ruleAttr.ruleAttrAddStatus
      }
    },
    ruleAddFormFun(){
      if (this.ruleAddForm.name === null || this.ruleAddForm.name.length === 0){
        this.$message({
          message: '规格名称不可为空',
          type: 'warning'
        });
        return;
      }
      if (this.ruleAddForm.valueList === null || this.ruleAddForm.valueList.length === 0){
        this.$message({
          message: '规格属性不可为空',
          type: 'warning'
        });
        return;
      }

      let ruleAttr = this.form.ruleAttrList.find(ruleAttr => ruleAttr.name === this.ruleAddForm.name);
      if (ruleAttr === undefined){
        this.form.ruleAttrList.push({
          "name": this.ruleAddForm.name,
          "valueList": [this.ruleAddForm.valueList],
          "ruleAttrAddStatus": false
        })
      }else {
        if (ruleAttr.valueList.indexOf(this.ruleAddForm.valueList) > -1){
          this.$message({
            message: `规格[${this.ruleAddForm.name}]属性值[${this.ruleAddForm.valueList}]已经存在`,
            type: 'warning'
          });
          return;
        }
        ruleAttr.valueList.push(this.ruleAddForm.valueList)
      }
      this.ruleAddForm = {
        name: null,
        valueList: null,
      }
      this.ruleAddFormStatus = false;
    },
    /** 查询商品规格列表 */
    getList() {
      this.loading = true;
      listRule(this.queryParams).then(response => {
        this.ruleList = response.data.rows;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        name: null,
        status: null,
        remark: null,
        ruleAttrList:[]
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加商品规格";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids
      getRule(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改商品规格";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateRule(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRule(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$modal.confirm('是否确认删除商品规格编号为"' + ids + '"的数据项？').then(function() {
        return delRule(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('product/rule/export', {
        ...this.queryParams
      }, `rule_${new Date().getTime()}.xlsx`)
    },
    updRuleUpdStatus(row){
      let text=row.status ==='Y' ? '启用' : '禁用'
      this.$modal.confirm('确定要'+text+""+row.id+"管理吗?").then(()=>{
        updateStatusRule(row.id,row.status).then(res=>{
          this.$modal.msgSuccess(text + "成功")
        })
      })
    }
  }
};
</script>
